#!/usr/local/bin/python

"""
The Semantic Web Pigeon. Or maybe Pidgin.
Interactive top-level
Max Goldman and Robin Stewart
"""

from agent import *

#
# Create the "agent" that manages parsing
#
agent = Agent()

#
# Tell the agent about interesting types of things
# This could eventually be done dynamically
#
# Parsers based on sem-web lookup:
agent.add_sw_parser("models/people", "entities/people.n3")
agent.add_sw_parser("models/places", "entities/places.n3")
agent.add_sw_parser("models/meetings")
agent.add_sw_parser("models/contacts")

# Parsers based on regular expressions:
agent.add_ground_parser(DateTimeParser())
agent.add_ground_parser(EmailParser())

print "Ready"

#
# Give it a go: interpret input
#
#agent.interpret("alice G531")
#agent.interpret("david karger tomorrow 6pm stata")
while True:
    try:
        input = raw_input("\n> ")
        if input in [ "exit", "quit" ]:
            raise EOFError
    except (EOFError, KeyboardInterrupt):
        print
        quit()

    if input.strip() == "":
        print "Please enter some text."
        continue

    result = agent.interpret(input)
    if result:
        print "Success"
        agent.print_token(result)
    else:
        print "Don't know what to do."
